
--Configuration
local barTexture = "Interface\\AddOns\\MicroHUD\\Minimalist"
local targetFont = "GameFontNormalHuge"
local barFont = "GameFontNormal"
local buffFont = "GameFontWhiteTiny"

local barWidth = 170
local barHeight = 17

local vSpace = 1
local hOffset = barWidth * 1.25


--Get class color of unit.
local function cc(u)
  local col = {r = 1, g = 0, b = 0}
  local _, c = UnitClass(u)

  if c and UnitIsPlayer(u) then
    col = RAID_CLASS_COLORS[c]
  end

  return col
end


--Find debuff done by myself.
local function mydebuff(debuff)
  for i = 1, 40 do
	local n, _, _, _, _, d, t, u, _, _, _ = UnitDebuff("target", i)
	
	if n and d and t and u and n == debuff and u == "player" then
	  return d, t
	end
  end
  
  return nil, nil, nil
end


--Format large health and power numbers.
local function sn(h)
  if h > 999999 then
    return format("%.1fm", h / 1000000)
  elseif h > 9999 then
    return format("%.1fk", h / 1000)
  else
    return format("%d", h)
  end
end


--Top network latency bar.
local ns = CreateFrame("StatusBar")
ns:SetWidth(barWidth * 1.25)
ns:SetHeight(barHeight / 2)
ns:SetPoint("TOP")
ns:SetStatusBarTexture(barTexture)
ns:SetBackdrop({bgFile = barTexture})
ns:SetBackdropColor(0.1, 0.1, 0.1)
ns:SetMinMaxValues(0, 1000)
ns:RegisterEvent("CHAT_MSG_WHISPER")

local nst = ns:CreateFontString()
nst:SetFontObject(buffFont)
nst:SetAllPoints()

local ns2 = CreateFrame("StatusBar")
ns2:SetWidth(barWidth * 1.25)
ns2:SetHeight(barHeight / 2)
ns2:SetPoint("TOP", ns, "BOTTOM", 0, -vSpace)
ns2:SetStatusBarTexture(barTexture)
ns2:SetBackdrop({bgFile = barTexture})
ns2:SetBackdropColor(0.1, 0.1, 0.1)
ns2:SetMinMaxValues(0, 1000)

local ns2t = ns2:CreateFontString()
ns2t:SetFontObject(buffFont)
ns2t:SetAllPoints()

ns:SetScript("OnEvent",
  function(f, e, ...)
    PlaySound("ReadyCheck")
  end
)

local nset = 0

ns:SetScript("OnUpdate",
  function(self, elapsed)
    nset = nset + elapsed
	
	if nset > 0.5 then
      local _, _, h, w = GetNetStats()

	  ns:SetValue(h)
	  ns2:SetValue(w)

	  nst:SetFormattedText("Home %d ms", h)
	  ns2t:SetFormattedText("World %d ms", w)

      if h < 300 then
        ns:SetStatusBarColor(0, 1, 0)
      elseif h < 600 then
        ns:SetStatusBarColor(1, 1, 0)
      else
        ns:SetStatusBarColor(1, 0, 0)
      end

      if w < 300 then
        ns2:SetStatusBarColor(0, 1, 0)
      elseif w < 600 then
        ns2:SetStatusBarColor(1, 1, 0)
      else
        ns2:SetStatusBarColor(1, 0, 0)
      end
	  
  	  nset = 0
	end
  end
)


--Left side, player info.
local ph = CreateFrame("StatusBar")
ph:SetWidth(barWidth)
ph:SetHeight(barHeight)
ph:SetPoint("CENTER", UIParent, "CENTER", -hOffset, 0)
ph:SetStatusBarTexture(barTexture)
ph:SetStatusBarColor(0, 1, 0)
ph:SetBackdrop({bgFile = barTexture})
ph:SetBackdropColor(0.1, 0.1, 0.1)
ph:RegisterEvent("PLAYER_ENTERING_WORLD")
ph:RegisterEvent("PLAYER_REGEN_DISABLED")
ph:RegisterEvent("PLAYER_REGEN_ENABLED")
ph:RegisterEvent("UNIT_HEALTH")
ph:RegisterEvent("UNIT_MAXHEALTH")

local pht = ph:CreateFontString()
pht:SetFontObject(barFont)
pht:SetAllPoints()

ph:SetScript("OnEvent",
  function(f, e, ...)
    f:SetMinMaxValues(0, UnitHealthMax("player"))
    f:SetValue(UnitHealth("player"))
    pht:SetFormattedText("%s / %s", sn(UnitHealth("player")), sn(UnitHealthMax("player")))

	if e == "PLAYER_REGEN_DISABLED" then
	  SetCVar("nameplateShowFriends", 0)
	  SetCVar("nameplateShowEnemies", 1)
	elseif e == "PLAYER_REGEN_ENABLED" then
	  SetCVar("nameplateShowFriends", 0)
	  SetCVar("nameplateShowEnemies", 0)
    end
  end
)

local pp = CreateFrame("StatusBar")
pp:SetWidth(barWidth)
pp:SetHeight(barHeight)
pp:SetPoint("TOP", ph, "BOTTOM", 0, -vSpace)
pp:SetStatusBarTexture(barTexture)
pp:SetBackdrop({bgFile = barTexture})
pp:SetBackdropColor(0.1, 0.1, 0.1)
pp:RegisterEvent("PLAYER_ENTERING_WORLD")
pp:RegisterEvent("UNIT_DISPLAYPOWER")
pp:RegisterEvent("UNIT_POWER")
pp:RegisterEvent("UNIT_MAXPOWER")

local ppt = pp:CreateFontString()
ppt:SetFontObject(barFont)
ppt:SetAllPoints()

pp:SetScript("OnEvent",
  function(f, e, ...)
	local col = PowerBarColor[UnitPowerType("player")]
	  
	f:SetStatusBarColor(col.r, col.g, col.b)
	f:SetMinMaxValues(0, UnitPowerMax("player"))
	f:SetValue(UnitPower("player"))
	ppt:SetFormattedText("%s / %s", sn(UnitPower("player")), sn(UnitPowerMax("player")))
  end
)


--Left side DK runes.
local rbet = 0
local rb = {}
local rWidth = ((barWidth / 6) - vSpace) + (vSpace  / 6)

if select(2, UnitClass("player")) == "DEATHKNIGHT" then
rb[1] = CreateFrame("StatusBar")
rb[1]:SetWidth(rWidth)
rb[1]:SetHeight(barHeight)
rb[1]:SetOrientation("VERTICAL")
rb[1]:SetPoint("BOTTOMLEFT", ph, "TOPLEFT", 0, vSpace)
rb[1]:SetStatusBarTexture(barTexture)
rb[1]:SetBackdrop({bgFile = barTexture})
rb[1]:SetBackdropColor(0.1, 0.1, 0.1)

rb[2] = CreateFrame("StatusBar")
rb[2]:SetWidth(rWidth)
rb[2]:SetHeight(barHeight)
rb[2]:SetOrientation("VERTICAL")
rb[2]:SetPoint("LEFT", rb[1], "RIGHT", vSpace, 0)
rb[2]:SetStatusBarTexture(barTexture)
rb[2]:SetBackdrop({bgFile = barTexture})
rb[2]:SetBackdropColor(0.1, 0.1, 0.1)

rb[5] = CreateFrame("StatusBar")
rb[5]:SetWidth(rWidth)
rb[5]:SetHeight(barHeight)
rb[5]:SetOrientation("VERTICAL")
rb[5]:SetPoint("LEFT", rb[2], "RIGHT", vSpace, 0)
rb[5]:SetStatusBarTexture(barTexture)
rb[5]:SetBackdrop({bgFile = barTexture})
rb[5]:SetBackdropColor(0.1, 0.1, 0.1)

rb[6] = CreateFrame("StatusBar")
rb[6]:SetWidth(rWidth)
rb[6]:SetHeight(barHeight)
rb[6]:SetOrientation("VERTICAL")
rb[6]:SetPoint("LEFT", rb[5], "RIGHT", vSpace, 0)
rb[6]:SetStatusBarTexture(barTexture)
rb[6]:SetBackdrop({bgFile = barTexture})
rb[6]:SetBackdropColor(0.1, 0.1, 0.1)

rb[3] = CreateFrame("StatusBar")
rb[3]:SetWidth(rWidth)
rb[3]:SetHeight(barHeight)
rb[3]:SetOrientation("VERTICAL")
rb[3]:SetPoint("LEFT", rb[6], "RIGHT", vSpace, 0)
rb[3]:SetStatusBarTexture(barTexture)
rb[3]:SetBackdrop({bgFile = barTexture})
rb[3]:SetBackdropColor(0.1, 0.1, 0.1)

rb[4] = CreateFrame("StatusBar")
rb[4]:SetWidth(rWidth)
rb[4]:SetHeight(barHeight)
rb[4]:SetOrientation("VERTICAL")
rb[4]:SetPoint("LEFT", rb[3], "RIGHT", vSpace, 0)
rb[4]:SetStatusBarTexture(barTexture)
rb[4]:SetBackdrop({bgFile = barTexture})
rb[4]:SetBackdropColor(0.1, 0.1, 0.1)

rb[1]:SetScript("OnUpdate",
  function(f, e)
	rbet = rbet + e
	
    if rbet > 0.1 then
	  for i = 1, 6 do
		local s, d, r = GetRuneCooldown(i)
		local t = GetRuneType(i)

		if r then
		  rb[i]:SetMinMaxValues(0, 1)
		  rb[i]:SetValue(1)

		  if t == 1 then
		    rb[i]:SetStatusBarColor(1, 0, 0)
		  elseif t == 2 then
		    rb[i]:SetStatusBarColor(0, 1, 0)
		  elseif t == 3 then
		    rb[i]:SetStatusBarColor(0, 1, 1)
		  else
		    rb[i]:SetStatusBarColor(1, 0, 1)
		  end
		else
		  local tl = GetTime() - s

		  rb[i]:SetMinMaxValues(1, d)
		  rb[i]:SetValue(tl)

		  if t == 1 then
		    rb[i]:SetStatusBarColor(0.5, 0, 0)
		  elseif t == 2 then
		    rb[i]:SetStatusBarColor(0, 0.5, 0)
		  elseif t == 3 then
		    rb[i]:SetStatusBarColor(0, 0.5, 0.5)
		  else
		    rb[i]:SetStatusBarColor(0.5, 0, 0.5)
		  end
		end
	  end

	  rbet = 0
	end
  end
)
end


--Right side, target info.
local th = CreateFrame("StatusBar")
th:SetWidth(barWidth)
th:SetHeight(barHeight)
th:SetPoint("CENTER", UIParent, "CENTER", hOffset, 0)
th:SetStatusBarTexture(barTexture)
th:SetStatusBarColor(1, 0, 0)
th:SetBackdrop({bgFile = barTexture})
th:SetBackdropColor(0.1, 0.1, 0.1)
th:RegisterEvent("PLAYER_TARGET_CHANGED")
th:RegisterEvent("RAID_TARGET_UPDATE")
th:RegisterEvent("UNIT_NAME_UPDATE")
th:RegisterEvent("UNIT_HEALTH")
th:RegisterEvent("UNIT_MAXHEALTH")
th:Hide()

local tht = th:CreateFontString()
tht:SetFontObject(barFont)
tht:SetAllPoints()

local tn = UIParent:CreateFontString()
tn:SetFontObject(targetFont)
tn:SetPoint("BOTTOM", th, "TOP", 0, 2 * vSpace)

local tcls = UIParent:CreateFontString()
tcls:SetFontObject(targetFont)
tcls:SetPoint("BOTTOM", tn, "TOP", 0, 2 * vSpace)

local ri = UIParent:CreateTexture()
ri:SetHeight(barHeight * 2)
ri:SetWidth(barHeight * 2)
ri:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
ri:SetPoint("RIGHT", th, "LEFT", -2 * vSpace, 0)
ri:Hide()

local dbar = CreateFrame("StatusBar")
dbar:SetWidth(barWidth)
dbar:SetHeight(barHeight)
dbar:SetPoint("BOTTOM", tcls, "TOP", 0, 2 * vSpace)
dbar:SetStatusBarTexture(barTexture)
dbar:SetStatusBarColor(0.6, 0.3, 0.4)
dbar:SetBackdrop({bgFile = barTexture})
dbar:SetBackdropColor(0.1, 0.1, 0.1)
dbar:Hide()

local thet = 0

th:SetScript("OnUpdate",
  function(f, e)
	thet = thet + e
	
    if thet > 0.1 then
	  local d, t = mydebuff("Frost Fever")
	  local d2, t2 = mydebuff("Blood Plague")
	  
	  if d and t and d2 and t2 then
		if t2 < t then
		  d = d2
		  t = t2
		end

	    dbar:SetMinMaxValues(0, d)
	    dbar:SetValue(t - GetTime())

		if dbar:GetValue() < (d / 4) then
		  dbar:SetHeight(barHeight * 2)
		elseif dbar:GetValue() < (d / 2) then
		  dbar:SetHeight(barHeight)
		else
		  dbar:SetHeight(barHeight / 2)
		end

	    dbar:Show()
	  else
	    dbar:Hide()
	  end

      thet = 0
    end
  end
)

th:SetScript("OnEvent",
  function(f, e, ...)
      if UnitExists("target") and UnitHealthMax("target") > 0 then
        local i = GetRaidTargetIndex("target")
        local c = cc("target")

        if i then
          SetRaidTargetIconTexture(ri, i)
          ri:Show()
        else
          ri:Hide()
        end

		f:SetStatusBarColor(c.r, c.g, c.b)
        f:SetMinMaxValues(0, UnitHealthMax("target"))
        f:SetValue(UnitHealth("target"))
        tht:SetFormattedText("%s / %s = %.1f%%", sn(UnitHealth("target")), sn(UnitHealthMax("target")), (100 * UnitHealth("target")) / UnitHealthMax("target"))
        tn:SetText(UnitName("target"))
        f:Show()
      else
        f:Hide()
        ri:Hide()
		dbar:Hide()
        tn:SetText("")
		tcls:SetText("")
      end
  end
)

local tp = CreateFrame("StatusBar")
tp:SetWidth(barWidth)
tp:SetHeight(barHeight)
tp:SetPoint("TOP", th, "BOTTOM", 0, -vSpace)
tp:SetStatusBarTexture(barTexture)
tp:SetBackdrop({bgFile = barTexture})
tp:SetBackdropColor(0.1, 0.1, 0.1)
tp:RegisterEvent("PLAYER_TARGET_CHANGED")
tp:RegisterEvent("UNIT_DISPLAYPOWER")
tp:RegisterEvent("UNIT_POWER")
tp:RegisterEvent("UNIT_MAXPOWER")
tp:Hide()

local tpt = tp:CreateFontString()
tpt:SetFontObject(barFont)
tpt:SetAllPoints()

tp:SetScript("OnEvent",
  function(f, e, ...)
    if UnitExists("target") and UnitPowerMax("target") > 0 then
      local col = PowerBarColor[UnitPowerType("target")]

      f:SetStatusBarColor(col.r, col.g, col.b)
      f:SetMinMaxValues(0, UnitPowerMax("target"))
      f:SetValue(UnitPower("target"))
	  tpt:SetFormattedText("%s / %s = %.1f%%", sn(UnitPower("target")), sn(UnitPowerMax("target")), (100 * UnitPower("target")) / UnitPowerMax("target"))
      f:Show()
    else
      f:Hide()
    end
  end
)


--Right side threat information.
local tt = CreateFrame("StatusBar")
tt:SetWidth(barWidth)
tt:SetHeight(barHeight)
tt:SetPoint("TOP", tp, "BOTTOM", 0, -vSpace)
tt:SetStatusBarTexture(barTexture)
tt:SetBackdrop({bgFile = barTexture})
tt:SetBackdropColor(0.1, 0.1, 0.1)
tt:SetMinMaxValues(0, 100)
tt:RegisterEvent("PLAYER_TARGET_CHANGED")
tt:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
tt:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
tt:Hide()
tt:SetScript("OnEvent",
  function(f, e, ...)
      if UnitExists("target") then
        local _, s, p, _, _ = UnitDetailedThreatSituation("player", "target")
        local r, g, b = GetThreatStatusColor(s)

        if p == nil then
          f:Hide()
        else
          f:SetStatusBarColor(r, g, b)
          f:SetValue(p)
          f:Show()
		end
      else
        f:Hide()
      end
  end
)


--Center damage taken.
local dtet = 0

local dt = CreateFrame("StatusBar")
dt:SetWidth(barWidth * 1.5)
dt:SetHeight(barHeight * 1)
dt:SetPoint("CENTER", UIParent, "CENTER", 0, -barHeight * 4)
dt:SetStatusBarTexture(barTexture)
dt:SetStatusBarColor(1, 0, 0)
dt:SetBackdrop({bgFile = barTexture})
dt:SetBackdropColor(0.1, 0.1, 0.1)
dt:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
dt:Hide()

local dtt = dt:CreateFontString()
dtt:SetFontObject(barFont)
dtt:SetAllPoints()

dt:SetScript("OnUpdate",
  function(f, e)
	dtet = dtet + e
	
    if dtet > 2 then
	  dt:Hide()
      dtet = 0
    end
  end
)

dt:SetScript("OnEvent",
  function(f, e, ...)
    local src = "Unknown"
    local dmg = 0
	local timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, misc1, misc2, misc3, misc4, misc5, misc6, misc7 = ...

	if destGUID == UnitGUID("player") then
	  if eventType == "SWING_DAMAGE" then
        src = sourceName
        dmg = misc1 ~= "ABSORB" and misc1 or 0
      end

	  if eventType == "SPELL_PERIODIC_DAMAGE" or eventType == "SPELL_DAMAGE" or eventType == "DAMAGE_SHIELD" or eventType == "DAMAGE_SPLIT" or eventType == "RANGE_DAMAGE" then
        src = misc2
        dmg = misc4 ~= "ABSORB" and misc4 or 0
      end

      if eventType == "ENVIRONMENTAL_DAMAGE" then
        src = misc1
        dmg = misc2 ~= "ABSORB" and misc2 or 0
      end

      if dmg > 0 then
        dt:SetMinMaxValues(0, UnitHealth("player"))
        dt:SetValue(dmg)
        dtt:SetText(src)
        dt:Show()

        dtet = 0
      end
    end
  end
)


--Center target casting.
local cfet = 0

local cf = CreateFrame("StatusBar")
cf:SetWidth(barWidth * 1.5)
cf:SetHeight(barHeight)
cf:SetPoint("CENTER", UIParent, "CENTER", 0, barHeight * 4)
cf:SetStatusBarTexture(barTexture)
cf:SetStatusBarColor(0, 0, 0, 0)
cf:SetBackdrop({bgFile = barTexture})
cf:SetBackdropColor(0, 0, 0, 0)

local cft = cf:CreateFontString()
cft:SetFontObject(barFont)
cft:SetTextColor(0, 0, 0, 0)
cft:SetAllPoints()

cf:SetScript("OnUpdate",
  function(f, e)
   cfet = cfet + e

    if cfet > 0.1 then
	  local spell, _, displayName, _, startTime, endTime, _, _, interrupt = UnitCastingInfo("target")
	  
	  if not spell then
		spell, _, displayName, _, startTime, endTime, _, interrupt = UnitChannelInfo("target")
	  end

	  if spell then
		cft:SetText(displayName)
		cf:SetMinMaxValues(startTime, endTime)
		cf:SetValue(1000 * GetTime())

		if not interrupt then
		  cf:SetStatusBarColor(0.1, 0.1, 0.1, 1)
		  cf:SetBackdropColor(0.1, 1, 0.1, 1)
		  cft:SetTextColor(1, 1, 1, 1)
		else
		  cf:SetStatusBarColor(1, 0.1, 0.1, 1)
		  cf:SetBackdropColor(0.1, 0.1, 0.1, 1)
		  cft:SetTextColor(0.9, 0.9, 0.9, 1)
		end
	  else
		cf:SetStatusBarColor(0, 0, 0, 0)
		cf:SetBackdropColor(0, 0, 0, 0)
	    cft:SetTextColor(0, 0, 0, 0)
	  end
	  
	  cfet = 0
	end
  end
)
